edu.wpi.first.wpilibj.interfaces

## Interface Gyro

- All Known Implementing Classes:
    ADXRS450_Gyro, AnalogGyro, GyroBase

      public interface Gyro

  Interface for yaw rate gyros.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `calibrate()` Calibrate the gyro by running for a number of samples and computing the center value.
    `void` | `free()` Free the resources used by the gyro.
    `double` | `getAngle()` Return the actual angle in degrees that the robot is currently facing.
    `double` | `getRate()` Return the rate of rotation of the gyro.
    `void` | `reset()` Reset the gyro.

- - ### Method Detail

    - #### calibrate

          void calibrate()

      Calibrate the gyro by running for a number of samples and computing the center value. Then use the center value as the Accumulator center value for subsequent measurements. It's important to make sure that the robot is not moving while the centering calculations are in progress, this is typically done when the robot is first turned on while it's sitting at rest before the competition starts.

    - #### reset

          void reset()

      Reset the gyro. Resets the gyro to a heading of zero. This can be used if there is significant drift in the gyro and it needs to be recalibrated after it has been running.

    - #### getAngle

          double getAngle()

      Return the actual angle in degrees that the robot is currently facing.

      The angle is based on the current accumulator value corrected by the oversampling rate, the gyro type and the A/D calibration values. The angle is continuous, that is it will continue from 360 to 361 degrees. This allows algorithms that wouldn't want to see a discontinuity in the gyro output as it sweeps past from 360 to 0 on the second time around.

      This heading is based on integration of the returned rate from the gyro.

      Returns:
        the current heading of the robot in degrees.

    - #### getRate

          double getRate()

      Return the rate of rotation of the gyro.

      The rate is based on the most recent reading of the gyro analog value

      Returns:
        the current rate in degrees per second

    - #### free

          void free()

      Free the resources used by the gyro.